---
layout: documentation
title: Getting Started with MvvmCross
category: Getting-started
order: 1
---
NuGet | Continuous Integration
-------|-----------
[![NuGet](https://img.shields.io/nuget/v/MvvmCross.svg)](https://www.nuget.org/packages/MvvmCross/) | [![MyGet](https://img.shields.io/myget/mvvmcross/v/MvvmCross.svg)](https://www.myget.org/F/mvvmcross/api/v3/index.json)

## Introduction

MvvmCross is a cross-platform MVVM framework that enables developers to create powerful cross platform apps. It supports Xamarin.iOS, Xamarin.Android, Xamarin.Mac, Xamarin.Forms, Universal Windows Platform (UWP) and Windows Presentation Framework (WPF).

The high level features that MvvmCross provides you with are:
* MVVM architecture pattern
* Navigation system
* Data Binding
* Platform specifics support
* Inversion of control and Dependency Injection
* Lots of plugins for common functionalities
* Unit test helpers
* Complete flexibility - your app is King!

## Your first project with Xamarin and MvvmCross

Here is a video that will help you creating a project from scratch with Xamarin and MvvmCross:

[https://www.youtube.com/watch?v=NihmK6R9r4s](https://www.youtube.com/watch?v=NihmK6R9r4s)

It gives all the detailed steps for a solution that includes a _Core_ PCL and app projects for iOS, Android and Windows Phone.

Here is the article that contains the text version:

[http://jonathanroux.com/2016/02/09/mvvmcross-4-and-xamarin-project-setup/](http://jonathanroux.com/2016/02/09/mvvmcross-4-and-xamarin-project-setup/)

## MvvmCross Templates

You can also install the templates for Visual Studio and Xamarin Studio:

Name | Author | Link
---- | --------- | -------
XabluCross for MvvmCross | XabluCross | [Visual Studio](https://marketplace.visualstudio.com/items?itemName=XabluCross.XabluCrossVSPackage)
MvvmCross for Visual Studio | Jim Bennett | [Visual Studio](https://marketplace.visualstudio.com/items?itemName=JimBobBennett.MvvmCrossforVisualStudio-19327) - [Visual Studio for Mac](http://addins.monodevelop.com/Project/Index/227)
MvvmCross Plugin Template for Visual Studio | EShy | [Visual Studio](https://marketplace.visualstudio.com/items?itemName=EShy.MvvmCrossPluginTemplateforVisualStudio)
Xamarin MvvmCross Dreams | Artmdev | [Visual Studio](https://marketplace.visualstudio.com/items?itemName=Artmdev.XamarinMvvmCrossDREAMS)
Xamarin Forms with MvvmCross Solution Template | Cristian Chereches | [Visual Studio](https://marketplace.visualstudio.com/items?itemName=CristianChereches.XamarinFormswithMvvmCrossSolutionTemplate)
Ninja Coder For MvvmCross and Xamarin Forms | Ninja Coder for MvvmCross | [Visual Studio](https://marketplace.visualstudio.com/items?itemName=NinjaCoderforMvvmCross.NinjaCoderForMvvmCrossandXamarinForms)
MVXTemplates | Luke Pothier | [Visual Studio](https://marketplace.visualstudio.com/items?itemName=LukePothier.MVXTemplates)

You can choose to download and install an extension manually, or you can get it from the Extension Manager in Visual Studio / the Add-In Gallery in Xamarin Studio (Visual Studio for Mac).


## Help updating the docs!

Everyone can contribute and help improving the docs! The docs are part of the source tree, so just go over to github and help us out!

