---
layout: documentation
title: MvvmCross Packages
category: Getting-started
order: 3
---
MvvmCross is a very extensible framework. There is a lot already been made by the community which you can use. On this page you will find the MvvmCross nuget packages currently available.

Name | Description | Link
---- | ----------- | ----
`MvvmCross.StarterPack`        | When starting a fresh project you should install this nuget. This will add all files to get you started. Afterwards you need to remove the nuget reference again manually from all your `packages.config` files (not through Nuget as this will delete the source files). | [NuGet](https://www.nuget.org/packages/MvvmCross.StarterPack/)
`MvvmCross.Forms.StarterPack`  | When starting a fresh Xamarin Forms project and want to use MvvmCross you should install this nuget. This will add all files to get started. In the core project you will find a ToDo file to get the project working. | [NuGet](https://www.nuget.org/packages/MvvmCross.Forms.StarterPack/)
`MvvmCross`                    | Main nuget. This will add Core and Binding. | [NuGet](https://www.nuget.org/packages/MvvmCross/)
`MvvmCross.Platform`           | Contains the libraries for all the separate platforms. | [NuGet](https://www.nuget.org/packages/MvvmCross.Platform/)
`MvvmCross.Core`               | Core libraries for the base of your app. | [NuGet](https://www.nuget.org/packages/MvvmCross.Core/)
`MvvmCross.Forms`              | Main nuget for Xamarin Forms. | [NuGet](https://www.nuget.org/packages/MvvmCross.Forms/)
`MvvmCross.Tests`              | Test helpers | [NuGet](https://www.nuget.org/packages/MvvmCross.Tests/)
`MvvmCross.Console.Platform`   |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Console.Platform/)
`MvvmCross.CodeAnalysis`       | Code fixes for MvvmCross | [NuGet](https://www.nuget.org/packages/MvvmCross.CodeAnalysis/)
`MvvmCross.Binding`            | Bindings system for all platforms | [NuGet](https://www.nuget.org/packages/MvvmCross.Binding/)
`MvvmCross.BindingEx`          |  | [NuGet](https://www.nuget.org/packages/MvvmCross.BindingEx/)


## Android Support

Name | Description | Link
---- | ----------- | ----
`MvvmCross.Droid.Support.V4`              |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Droid.Support.V4/)
`MvvmCross.Droid.Support.V7.AppCompat`    | AppCompat for MvvmCross | [NuGet](https://www.nuget.org/packages/MvvmCross.Droid.Support.V7.AppCompat/)
`MvvmCross.Droid.Support.V7.Fragging`     | Android support fragments, caching and helpers | [NuGet](https://www.nuget.org/packages/MvvmCross.Droid.Support.V7.Fragging/)
`MvvmCross.Droid.Support.V7.Preference`   |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Droid.Support.V7.Preference/)
`MvvmCross.Droid.Support.V7.RecyclerView` |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Droid.Support.V7.RecyclerView/)
`MvvmCross.Droid.Support.V14.Preference`  |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Droid.Support.V14.Preference/)
`MvvmCross.Droid.Support.V17.Leanback`    |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Droid.Support.V17.Leanback/)
`MvvmCross.Droid.Support.Design`          |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Droid.Support.Design/)


## iOS Support

Name | Description | Link
---- | ----------- | ----
`MvvmCross.iOS.Support`                | Helpers, featured ViewPresenters and Base classes for iOS | [NuGet](https://www.nuget.org/packages/MvvmCross.iOS.Support/)
`MvvmCross.iOS.Support.JASidePanels`   | Implementation for `JASidePanels` library                 | [NuGet](https://www.nuget.org/packages/MvvmCross.iOS.Support.JASidePanels/)
`MvvmCross.iOS.Support.XamarinSidebar` | Implementation for `XamarinSidebar` library               | [NuGet](https://www.nuget.org/packages/MvvmCross.iOS.Support.XamarinSidebar/)


## Plugins

Name | Description | Link
---- | ----------- | ----
`MvvmCross.Plugin.All`              |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.All/)
`MvvmCross.Plugin.Accelerometer`    |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.Accelerometer/)
`MvvmCross.Plugin.Bookmarks`        |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.Bookmarks/)
`MvvmCross.Plugin.Color`            |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.Color/)
`MvvmCross.Plugin.DownloadCache`    |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.DownloadCache/)
`MvvmCross.Plugin.Email`            |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.Email/)
`MvvmCross.Plugin.FieldBinding`     |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.FieldBinding/)
`MvvmCross.Plugin.File`             |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.File/)
`MvvmCross.Plugin.Json`             |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.Json/)
`MvvmCross.Plugin.JsonLocalization` |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.JsonLocalization/)
`MvvmCross.Plugin.Location`         |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.Location/)
`MvvmCross.Plugin.Messenger`        |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.Messenger/)
`MvvmCross.Plugin.MethodBinding`    |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.MethodBinding/)
`MvvmCross.Plugin.Network`          |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.PhoneCall/)
`MvvmCross.Plugin.PictureChooser`   |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.PictureChooser/)
`MvvmCross.Plugin.ReflectionEx`     |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.ReflectionEx/)
`MvvmCross.Plugin.ResourceLoader`   |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.ResourceLoader/)
`MvvmCross.Plugin.Share`            |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.Share/)
`MvvmCross.Plugin.SoundEffects`     |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.SoundEffects/)
`MvvmCross.Plugin.SQLitePCL`        |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.SQLitePCL/)
`MvvmCross.Plugin.ThreadUtils`      |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.ThreadUtils/)
`MvvmCross.Plugin.Visibility`       |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.Visibility/)
`MvvmCross.Plugin.WebBrowser`       |  | [NuGet](https://www.nuget.org/packages/MvvmCross.Plugin.WebBrowser/)

